#include "xml.h"
#include <shlwapi.h>
#include <commctrl.h>
#include <tchar.h>
#pragma comment(linker,"/NOD /OPT:NOWIN98")
#pragma intrinsic(memset)
#define elemof(x) (sizeof(x)/sizeof(*(x)))
enum{
 MB_SOUND	=0x80000000,
 GAPX = 4,
 MINW = 32,
};

static HINSTANCE hInstance;
static HWND hMainWnd,hDialog;
static HWND hToolbar,hStatus;
static HWND hWndX[3];
#define hTreeView hWndX[0]
#define hListView hWndX[1]
#define hComment hWndX[2]
static HWND hFind;
static UINT msgFind;
static FINDREPLACE findreplace;
static TCHAR findstr[80],replacestr[80];
static HMENU hMainMenu;
static TCHAR MBoxTitle[64];

// Worker-Thread: Es gibt 0 oder 1 Thread der im Hintergrund arbeitet
// Der Thread muss bei Ende PostMessage(hMainWnd,WM_USER+1,x,y) aufrufen!
static HANDLE hWorkerThread;
volatile bool wantStop;

static void stopWorker() {
 if (!hWorkerThread) return;
 wantStop=true;
 MSG msg;
 GetMessage(&msg,hMainWnd,WM_USER+1,WM_USER+1);	// Auf Beendigung des Threads lauern
 CloseHandle(hWorkerThread);
 hWorkerThread=0;
 wantStop=false;
}

static bool startWorker(PTHREAD_START_ROUTINE f,void*p) {
 if (hWorkerThread) stopWorker();
 DWORD threadid;
 return !!(hWorkerThread=CreateThread(0,0,f,p,0,&threadid));
}

static struct CurrentFile{
 Xml xml;
 DWORD packer_id;	// zum Wiedereinpacken
 TCHAR name[MAX_PATH];
 bool open() {return startWorker(load,this);}
 void close();
 bool save();
 bool load();
 bool unzip(HANDLE&);
 static DWORD _stdcall load(void*p) {return ((CurrentFile*)p)->load();}
 static bool process(HANDLE&,const char*command,bool=false);
 static bool convertFile(HANDLE h1, HANDLE h2,const char*command);
}currentFile;
static TCHAR CustFilter[64];

static struct Config{
 short left,top,right,bottom;	// Fensterposition in Pixel
 char showCmd,flags;
 WORD paneX[2];	// 2 Abschnitte
 WORD listDiv[3];	// 3 oder 4 Spalten
 bool load();
 bool save();
 void ensurePanes(int w);
 int findDivider(int);
}config;

void Config::ensurePanes(int w) {
 int paneLast=0;
 for (unsigned i=0; i<elemof(paneX); i++) {
  int x=paneX[i],
      a=paneLast+MINW,
      e=w-(MINW+GAPX)*(elemof(paneX)-i);
  if (x<a) x=a;
  if (x>e) x=e;
  paneX[i]=paneLast=x;
 }
}

int Config::findDivider(int mouseX) {
 for (unsigned i=0; i<elemof(paneX); i++) {
  int x=paneX[i];
  if (x<=mouseX && mouseX<x+GAPX) return i;
 }
 return -1;
}

bool Config::load() {
 bool ret=false;
 HKEY k1;
 if (!RegOpenKeyEx(HKEY_CURRENT_USER,TEXT("Software\\h#s"),0,KEY_READ,&k1)) {
  HKEY k2;
  if (!RegOpenKeyEx(k1,TEXT("CdCat"),0,KEY_READ,&k2)) {
   DWORD sz=sizeof*this;
   if (!RegQueryValueEx(k2,TEXT("Config"),0,0,(BYTE*)this,&sz) && sz>=9) {
    WINDOWPLACEMENT wp;
    wp.length=sizeof wp;
    GetWindowPlacement(hMainWnd,&wp);
    RECT&R=wp.rcNormalPosition;
    R.left=left;
    R.top=top;
    R.right=right;
    R.bottom=bottom;
    wp.showCmd=showCmd;
    SetWindowPlacement(hMainWnd,&wp);
    ret=true;
   }
   sz=sizeof currentFile.name;
   if (!RegQueryValueEx(k2,TEXT("File"),0,0,(BYTE*)currentFile.name,&sz)) flags|=1;
   RegCloseKey(k2);
  }
  RegCloseKey(k1);
 }
 return ret;
}

bool Config::save() {
 bool ret=false;
 HKEY k1;
 if (!RegCreateKeyEx(HKEY_CURRENT_USER,TEXT("Software\\h#s"),0,0,0,KEY_WRITE,0,&k1,0)) {
  HGLOBAL hRes=LoadResource(0,FindResource(0,MAKEINTRESOURCE(1),RT_VERSION));
  void*pRes=LockResource(hRes);
  struct {WORD lang,cp;}*langcp;
  UINT cb;
  VerQueryValue(pRes,TEXT("\\VarFileInfo\\Translation"),(void**)&langcp,&cb);
  void*pText;
  TCHAR verQuery[128];
  wnsprintf(verQuery,elemof(verQuery),TEXT("\\StringFileInfo\\%04x%04x\\")SA,
  langcp[0].lang,langcp[0].cp,"CompanyName");
  VerQueryValue(pRes,verQuery,&pText,&cb);
  RegSetValueEx(k1,0,0,REG_SZ,(BYTE*)pText,cb*sizeof(TCHAR));
  HKEY k2;
  if (!RegCreateKeyEx(k1,TEXT("CdCat"),0,0,0,KEY_WRITE,0,&k2,0)) {
   wnsprintf(verQuery,elemof(verQuery),TEXT("\\StringFileInfo\\%04x%04x\\")SA,
   langcp[0].lang,langcp[0].cp,"FileDescription");
   VerQueryValue(pRes,verQuery,&pText,&cb);
   RegSetValueEx(k2,0,0,REG_SZ,(BYTE*)pText,cb*sizeof(TCHAR));
   WINDOWPLACEMENT wp;
   wp.length=sizeof wp;
   GetWindowPlacement(hMainWnd,&wp);
   RECT&R=wp.rcNormalPosition;
   left=(short)R.left;
   top=(short)R.top;
   right=(short)R.right;
   bottom=(short)R.bottom;
   showCmd=(char)wp.showCmd;
   if (!RegSetValueEx(k2,TEXT("Config"),0,REG_BINARY,(BYTE*)this,sizeof*this)) ret=true;
   if (currentFile.name[0]) RegSetValueEx(k2,TEXT("File"),0,REG_SZ,(BYTE*)currentFile.name,
     (lstrlen(currentFile.name)+1)*sizeof(TCHAR));
   else RegDeleteValue(k2,TEXT("File"));
   RegCloseKey(k2);
  }
  UnlockResource(hRes);
  FreeResource(hRes);
  RegCloseKey(k1);
 }
 return ret;
}

static int vMBox(HWND parent,ULONG_PTR id, UINT flags, va_list va) {
  TCHAR s[256],tbuf[256],*t=tbuf;
  if (IS_INTRESOURCE(id)) LoadString(hInstance,(UINT)id,tbuf,elemof(tbuf));
  else t=(TCHAR*)id;
  s[_vsntprintf(s,elemof(s)-1,t,va)]=0;
  if (flags&MB_SOUND) MessageBeep(flags&MB_ICONMASK);
  return MessageBox(parent,s,MBoxTitle,flags&~MB_SOUND);
}

static int _cdecl MBox(HWND parent,ULONG_PTR id,UINT flags,...) {
  va_list va;
  va_start(va,flags);
  int r=vMBox(parent,id,flags,va);
  va_end(va);
  return r;
}

// Datei durch Aufruf eines externen Kommandozeilen-Packers/Entpackers konvertieren
// Diese werden zu Standard-Ein- und -Ausgabe des Prozesses.
bool CurrentFile::convertFile(HANDLE h1, HANDLE h2,const char*command) {
 STARTUPINFO si;
 ZeroMemory(&si,sizeof si);
 si.cb=sizeof si;
 si.dwFlags=STARTF_USESTDHANDLES;
 SetHandleInformation(h1,HANDLE_FLAG_INHERIT,HANDLE_FLAG_INHERIT);
 SetHandleInformation(h2,HANDLE_FLAG_INHERIT,HANDLE_FLAG_INHERIT);
 si.hStdInput=h1;
 si.hStdOutput=h2;
 si.hStdError=h2;
 PROCESS_INFORMATION pi;
 TCHAR cmdline[16];
 wnsprintf(cmdline,elemof(cmdline),SA,command);
 if (!CreateProcess(0,cmdline,0,0,TRUE,CREATE_NO_WINDOW,0,0,&si,&pi)) return false;
 CloseHandle(pi.hThread);
 CloseHandle(pi.hProcess);
 CloseHandle(h1);
 CloseHandle(h2);
 return true;
}

bool CurrentFile::process(HANDLE&hFile,const char*command, bool compress) {
 HANDLE hr,hw;
 CreatePipe(&hr,&hw,0,Xml::BUFSIZE);
 if (compress) {
  if (!convertFile(hr,hFile,command)) return false;
  hFile=hw;
 }else{
  if (!convertFile(hFile,hw,command)) return false;
  hFile=hr;
 }
 return true;
}

bool CurrentFile::unzip(HANDLE&hFile) {
 DWORD br;
 ReadFile(hFile,&packer_id,4,&br,0);
 SetFilePointer(hFile,0,0,FILE_BEGIN);
 switch (packer_id) {
  case 0x00088B1F: if (!process(hFile,"gunzip")) return false; break;
  case 0x31685A42: if (!process(hFile,"bunzip2")) return false; break;
 }
 return true;
}

void status(const char*s) {
 int l=MultiByteToWideChar(CP_UTF8,0,s,-1,0,0);
 WCHAR*p=(WCHAR*)_alloca(l*sizeof(WCHAR));
 MultiByteToWideChar(CP_UTF8,0,s,-1,p,l);
 SetWindowTextW(hStatus,p);
}

void status(int id) {
 TCHAR s[256];
 LoadString(hInstance,id,s,elemof(s));
 SetWindowTextW(hStatus,s);
}

bool CurrentFile::load() {
 bool ok=true;
 HANDLE hFile=CreateFile(name,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0);
 if (hFile==INVALID_HANDLE_VALUE) ok=false;
 else{
  status(16);	// "Datei auspacken"
  unzip(hFile);
  if (wantStop) {ok=false; goto exi;}
  status(17);	// "Speicher anfordern"
  xml.hHeap=HeapCreate(HEAP_GENERATE_EXCEPTIONS|HEAP_NO_SERIALIZE,0,0);
  if (!xml.hHeap) ok=false;
 }
 if (wantStop) {ok=false; goto exi;}
 if (ok) {
  status(19);	// "XML parsen"
  ok=xml.parse(hFile);	// Hauptarbeit: Inhalt parsen
  if (!ok) {
   PostMessage(hMainWnd,WM_USER,xml.ec,0);
  }
 }
 if (wantStop) {ok=false; goto exi;}
 if (ok) {
  status(20);	//"Baum fllen"
  TVINSERTSTRUCT tvi;
  tvi.hParent=TVI_ROOT;
  tvi.hInsertAfter=TVI_LAST;
  tvi.item.mask=TVIF_CHILDREN|TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE;
  tvi.item.state=tvi.item.stateMask=TVIS_SELECTED|TVIS_EXPANDED;
  tvi.item.pszText=LPSTR_TEXTCALLBACK;
  tvi.item.iImage=tvi.item.iSelectedImage=I_IMAGECALLBACK;
  tvi.item.cChildren=I_CHILDRENCALLBACK;
  for (const fs::Entry*sn=xml.root.sub;sn;sn=sn->next) {
   tvi.item.lParam=(LPARAM)sn;
   TreeView_InsertItem(hTreeView,&tvi);
  }
  PostMessage(hMainWnd,WM_USER,0,0);	// fertig

  EnableMenuItem(hMainMenu,2,MF_ENABLED|MF_BYPOSITION);
  DrawMenuBar(hMainWnd);
  TCHAR s[64];
  wnsprintf(s,elemof(s),TEXT("%s - %s"),PathFindFileName(name),MBoxTitle);
  SetWindowText(hMainWnd,s);
 }
exi:
 PostMessage(hMainWnd,WM_USER+1,ok,0);
 return ok;
}

void CurrentFile::close() {
 TreeView_DeleteAllItems(hTreeView);
// Die Dateikopie und alle Knoten sind einfach in einem Heap!
// Dadurch ist nerviges delete nicht erforderlich!
 HeapDestroy(xml.hHeap); xml.hHeap=0;
 name[0]=0;
 SetWindowText(hMainWnd,MBoxTitle);
}

bool CurrentFile::save() {
 HANDLE hFile=CreateFile(name,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,0,0);
 if (hFile==INVALID_HANDLE_VALUE) return false;
 switch (packer_id) {
  case 0x00088B1F: if (!process(hFile,"gzip",true)) return false; break;
  case 0x31685A42: if (!process(hFile,"bzip2",true)) return false; break;
 }
 return xml.write(hFile);
}

static bool openfile(HWND parent) {
  OPENFILENAME ofn;
  ZeroMemory(&ofn,sizeof ofn);
  ofn.lStructSize=sizeof ofn;
  ofn.hwndOwner=parent;
  ofn.lpstrFile=currentFile.name;
  ofn.nMaxFile=elemof(currentFile.name);
  ofn.Flags=OFN_HIDEREADONLY|OFN_FILEMUSTEXIST;
  ofn.nFilterIndex=2;
  ofn.lpstrCustomFilter=CustFilter;
  ofn.nMaxCustFilter=elemof(CustFilter);
  TCHAR f[64];
  f[LoadString(hInstance,8,f,elemof(f)-1)+1]=0;
  ofn.lpstrFilter=f;
  if (!GetOpenFileName(&ofn)) return false;
  currentFile.open();
  return true;
}

BYTE classify(const fs::Entry*n,BYTE check=0xFF) {	// Liefert 1-aus-n-Bitmaske
 if (!n) return 0;			// nichts
 if (n->type&check) return n->type;
 return 0;
}

int nodeImage(const fs::Entry*n) {
 BYTE c=classify(n);
 if (c&eCatalog) return 0;	// Herz
 if (c&eFile) return 5;	// Blatt Papier
 if (c&eMedia) return n->medi;	// 1 = Quader, 2 = Glitzerscheibe
 return 3;	// Ordner geschlossen
}

int makeText(const char*src,TCHAR*dst,int len) {
 return MultiByteToWideChar(CP_UTF8,0,src,-1,dst,len);
}

int makeSizeString(unsigned __int64 sz,TCHAR*dst,int len) {
 return _sntprintf(dst,len,TEXT("%I64u"),sz);
}

int makeDateString(unsigned fatDate,TCHAR*dst,int len) {
 FILETIME ft;
 DosDateTimeToFileTime(HIWORD(fatDate),LOWORD(fatDate),&ft);
 SYSTEMTIME st;
 FileTimeToSystemTime(&ft,&st);
 int k=GetDateFormat(LOCALE_USER_DEFAULT,0,&st,0,dst,len);
 dst[k-1]=' ';
 return k+GetTimeFormat(LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT,&st,0,dst+k,len-k)-1;
}

static const fs::Entry*curDirListNode;	// Null bei Suchergebnissen

void addListItems(LVITEM&lvi) {
 for (lvi.iSubItem=0;lvi.iSubItem<3; lvi.iSubItem++) {
  if (!lvi.iSubItem) lvi.iItem=ListView_InsertItem(hListView,&lvi);
  else ListView_SetItem(hListView,&lvi);
 }
}

void makeDirList(const fs::Entry*n,bool updir=false) {
 if (!curDirListNode) updir=false;	// Wenn "woher" unbekannt dann niemals "updir"
 ListView_DeleteAllItems(hListView);
 LVITEM lvi;
 lvi.mask=LVIF_IMAGE|LVIF_PARAM|LVIF_STATE|LVIF_TEXT;
 lvi.iItem=0;
 int visIdx=-1;
 if (classify(n->parent,eCatalog|eMedia|eDir)) {
  lvi.iSubItem=0;
  lvi.state=updir?0:LVIS_SELECTED|LVIS_FOCUSED;	// Standardmig erste Zeile markieren
  lvi.iImage=6;
  lvi.pszText=L"..";	// Als erstes ".." anbieten
  lvi.lParam=LPARAM(n->parent);
  ListView_InsertItem(hListView,&lvi);
  if (!updir) visIdx=0;
  ++lvi.iItem;
 }
 lvi.iImage=I_IMAGECALLBACK;
 lvi.pszText=LPSTR_TEXTCALLBACK;

 for (const fs::Entry*sn=n->sub; sn; sn=sn->next) {
  if (classify(sn,eMedia|eDir|eFile)) {
	// Ganz entscheidend fr das Norton/Total-Commander-Feeling ist
	// dass die Zeile mit dem Woher markiert ist, wenn man ".." anklickte
   lvi.state=updir&&curDirListNode==sn?LVIS_SELECTED|LVIS_FOCUSED:0;
   lvi.lParam=LPARAM(sn);
   addListItems(lvi);
   if (lvi.state) visIdx=lvi.iItem;
   ++lvi.iItem;
  }
 }
 if (visIdx<0) {
  ListView_SetItemState(hListView,visIdx=0,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
 }
 ListView_EnsureVisible(hListView,visIdx,false);
 curDirListNode=n;			// wird fr Markierung bei Klick auf ".." bentigt
}

void handleTreeNotify(LPARAM lParam) {
 const NMHDR&nmhdr=*(NMHDR*)lParam;
 switch (nmhdr.code) {
  case TVN_SELCHANGED: {
   TVITEM&item=((NMTREEVIEW*)lParam)->itemNew;
   const fs::Entry*n=(const fs::Entry*)item.lParam;
   makeDirList(n);
  }break;
  case TVN_ITEMEXPANDED: {	// Umschalten zwischen geschlossenem und geffnetem Ordner
   NMTREEVIEW&nmtv=*((NMTREEVIEW*)lParam);
   if (nmtv.action&TVE_TOGGLE) {
    TVITEM&item=nmtv.itemNew;
    item.mask=TVIF_IMAGE|TVIF_SELECTEDIMAGE|TVIF_STATE|TVIF_CHILDREN;
    TreeView_GetItem(nmhdr.hwndFrom,&item);
    if (item.iImage==3 || item.iImage==4) {
     item.iImage=item.iSelectedImage=item.state&TVIS_EXPANDED?4:3;
     TreeView_SetItem(nmhdr.hwndFrom,&item);
    }
   }
  }break;
  case TVN_GETDISPINFO: {	// Voll dynamisches TreeView realisieren: Rasend schnell!
   TVITEM&item=((NMTVDISPINFO*)lParam)->item;
   const fs::Entry*n=(const fs::Entry*)item.lParam;
   if (item.mask&TVIF_CHILDREN) {
    item.cChildren=0;
    TVINSERTSTRUCT tvi;
    tvi.hParent=item.hItem;
    tvi.hInsertAfter=TVI_LAST;
    tvi.item.mask=TVIF_CHILDREN|TVIF_PARAM|TVIF_TEXT|TVIF_IMAGE|TVIF_SELECTEDIMAGE;
    tvi.item.pszText=LPSTR_TEXTCALLBACK;
    tvi.item.iImage=tvi.item.iSelectedImage=I_IMAGECALLBACK;
    tvi.item.cChildren=I_CHILDRENCALLBACK;
    for (const fs::Entry*sn=n->sub;sn;sn=sn->next) {
     if (classify(sn,eMedia|eDir)) {
      tvi.item.lParam=LPARAM(sn);
      TreeView_InsertItem(nmhdr.hwndFrom,&tvi);
      ++item.cChildren;
     }
    }
    UINT save=item.mask;
    item.mask=TVIF_CHILDREN;
    TreeView_SetItem(nmhdr.hwndFrom,&item);	// Keine weiteren Callbacks fr Kindknoten generieren!
    item.mask=save;	// (Komischerweise muss man hierzu das Item rckschreiben!)
   }
   if (item.mask&(TVIF_IMAGE|TVIF_SELECTEDIMAGE)) {
    item.iImage=item.iSelectedImage=nodeImage(n);
   }	// Kein Rckschreiben erforderlich!
   if (item.mask&TVIF_TEXT) makeText(n->name,item.pszText,item.cchTextMax);
  }
 }
}

// Pfad zum Knoten generieren mittels Rekursion
char*parentString(const fs::Entry*n,char*s,char*e) {
 if (n->parent) s=parentString(n->parent,s,e);
 if (e-s>1) *s++='/';	// "name" darf kein '/' enthalten!
 if (n->name) strncpy(s,n->name,e-s);
 return s+strlen(s);
}

void pathToStatus(const fs::Entry*n) {
 char s[260];
 parentString(n,s,s+elemof(s));
 status(s);
}

static ULONGLONG sumsize(const fs::Entry*n) {
 ULONGLONG ret=0;
 if (!wantStop) switch (classify(n,eMedia|eDir|eFile)) {
  case eMedia:
  case eDir: {
   for (const fs::Entry*sn=n->sub; sn; sn=sn->next) {
    ret+=sumsize(sn);	// Rekursion
    if (wantStop) break;
   }
  }break;
  case eFile: ret=n->size; break;
 }
 return ret;
}

static DWORD CALLBACK CalcSizeProc(void*param) {
 LVITEM*item=(LVITEM*)param;
 const fs::Entry*n=(const fs::Entry*)(item->lParam);
 ULONGLONG size=sumsize(n);
 if (!wantStop) {
  TCHAR buf[32], pre[2]={0};
  static const char siprefix[4]={'k','M','G','T'};
  for (int i=0; size>=1000000; i++) {	// Kommastellen erst mal nicht
   size/=1000; pre[0]=siprefix[i];
  }
  wnsprintf(buf,elemof(buf),TEXT("%u %sB"),(unsigned)size,pre);
  item->pszText=buf;
  ListView_SetItem(hListView,item);
 }
 delete item;
 PostMessage(hMainWnd,WM_USER+1,0,0);
 return 0;
}

// Stecknadel (Wortliste) <s> im Heuhaufen <d> suchen und bewerten
// Bewertungskriterien:
// * Anzahl der vorhandenen Matches
// * Trifft ganzes Wort oder Teilabschnitt
// * Gro/Kleinschreibung, Akzentzeichen gleich / ungleich
// * Reihenfolge gleich / ungleich
// Erst mal strstr fr Speicherbereich, also memstr
static int compare(const char*s, const char*d) {
 if (d) while (*d) {
  char c=*d++;
  if (c==*s) {
   const char*p=d;
   for (const char*q=s;
	(c=*++q) && *p;
	p++) if (*p!=c) break;
   if (!c) {
// am Ende: 98, am Anfang: 99, komplett gleich: 100    
    return 97;	// Zeichenkette enthalten
   }
  }
 }
 return 0;	// Kein Treffer
}

struct SuchThread{
 const fs::Entry*start;	// Start der Suche
 char s[64];		// Suchstring
 void findfunc(const fs::Entry*n) const {
  for(;n;n=n->next) {
   if (wantStop) return;
   int v=compare(s,n->name);
   if (v) {
    LVITEM item;
    item.mask=LVIF_IMAGE|LVIF_PARAM|LVIF_TEXT;
    item.iItem=100000;	// hinten
    item.iImage=I_IMAGECALLBACK;
    item.lParam=LPARAM(n);
    item.pszText=LPSTR_TEXTCALLBACK;
    addListItems(item);	// 1 Zeile, 3 Spalten
   }
   findfunc(n->sub);	// Rekursion
  }
 }
 static DWORD CALLBACK ThreadProc(void*p) {
  return ((SuchThread*)p)->ThreadProc();
 }
 DWORD ThreadProc() const{
  findfunc(start);
  ListView_SetItemState(hListView,0,LVIS_SELECTED|LVIS_FOCUSED,LVIS_SELECTED|LVIS_FOCUSED);
  delete const_cast<SuchThread*>(this);
  return PostMessage(hMainWnd,WM_USER+1,0,0);
 }
};

static bool suche(const fs::Entry*from,const char*s) {
 ListView_DeleteAllItems(hListView);
 curDirListNode=0;
 SuchThread*t=new SuchThread;
 t->start=from;
 strncpy(t->s,s,sizeof t->s);
 return startWorker(t->ThreadProc,t);
}

// Liefert finales HTREEITEM
// Lagenweise von oben nach unten, weil TVN_GETDISPINFO/TVIF_CHILDREN nebenher die Kinder generieren muss
static HTREEITEM treeShow(const fs::Entry*n) {
 if (!n) return TreeView_GetRoot(hTreeView);
 HTREEITEM p=treeShow(n->parent);
 TVITEM item;
 item.mask=TVIF_CHILDREN;
 item.hItem=p;
 TreeView_GetItem(hTreeView,&item);	//TODO: Sicherstellen dass die Kinder enumeriert sind!
 TreeView_Expand(hTreeView,p,TVE_EXPAND);

 item.mask=TVIF_PARAM;
 for (item.hItem=TreeView_GetChild(hTreeView,p);
	item.hItem;
	item.hItem=TreeView_GetNextSibling(hTreeView,item.hItem)) {
  TreeView_GetItem(hTreeView,&item);
  if (item.lParam==LPARAM(n)) return item.hItem;
 }
 return p;	// Lage berspringen (bld!)
}

static void handleListUI(const NMHDR*nm) {
 int idx;
 switch (nm->code) {
  case LVN_ITEMACTIVATE:
  case NM_CLICK:
  case NM_DBLCLK: idx=((const NMITEMACTIVATE*)nm)->iItem; break;	// ia.lParam enthlt Ramsch!
  case LVN_KEYDOWN: switch (((const NMLVKEYDOWN*)nm)->wVKey) {
   case VK_BACK: idx=0; break;
   default: idx=ListView_GetSelectionMark(nm->hwndFrom);
  }break;
  default: idx=ListView_GetSelectionMark(nm->hwndFrom);
 }
 if (idx>=0) {
  LVITEM item;					// Man muss es extra holen
  item.mask=LVIF_PARAM|LVIF_IMAGE;
  item.iItem=idx;
  item.iSubItem=0;
  ListView_GetItem(nm->hwndFrom,&item);
  const fs::Entry*n=(const fs::Entry*)item.lParam;
  switch (nm->code) {
   case LVN_ITEMACTIVATE:
   case NM_CLICK: pathToStatus(n); break;
   case LVN_KEYDOWN: switch (((const NMLVKEYDOWN*)nm)->wVKey) {
    case VK_BACK: if (item.iImage==6) goto back; break;	// Nichts tun wenn erste Zeile kein ".."
    case VK_SPACE: if (classify(n,eMedia|eDir) && !hWorkerThread) {
     item.iSubItem=1;
     item.mask=LVIF_TEXT;
     TCHAR buf[32];
     item.pszText=buf;
     item.cchTextMax=elemof(buf);
     ListView_GetItem(nm->hwndFrom,&item);
     if (buf[0]) break;				// Wenn Text existiert ist Gre bereits bekannt!
     item.pszText=L"??";
     ListView_SetItem(nm->hwndFrom,&item);	// Berechnung luft anzeigen
     startWorker(CalcSizeProc,new LVITEM(item));// Ruft das den Kopierkonstruktor auf den Plan
    }break;
    case VK_LEFT:
    case VK_RIGHT: {
     BYTE c=classify(n,eDir|eFile);
     if (!c) break;	// Medien nicht links aufblttern, Quatsch
     if (c&eFile) n=n->parent;
     HTREEITEM hItem=treeShow(n);
     if (hItem) {
      TreeView_EnsureVisible(hTreeView,hItem);
      TreeView_SelectItem(hTreeView,hItem);
     }
    }break;
    case VK_UP:
    case VK_DOWN:
    case VK_HOME:
    case VK_END:
    case VK_PRIOR:
    case VK_NEXT: SetTimer(hMainWnd,22,100,0); break;
   }break;
   case NM_DBLCLK:
   case NM_RETURN: if (classify(n,eCatalog|eMedia|eDir)) {
    back:makeDirList(n,item.iImage==6);
   }break;
  }
 }else if (nm->code==NM_CLICK) status("");		// daneben geklickt
}

void handleListNotify(LPARAM lParam) {
 const NMHDR&nmhdr=*(NMHDR*)lParam;
 switch (nmhdr.code) {
  case LVN_KEYDOWN:
  case LVN_ITEMACTIVATE:
  case NM_RETURN:
  case NM_CLICK:
  case NM_DBLCLK: handleListUI(&nmhdr); break;
  case LVN_GETDISPINFO: if (currentFile.xml.hHeap) {		// lParam ist shared ber alle iSubItem
   LVITEM&item=((NMLVDISPINFO*)lParam)->item;
   const fs::Entry*n=(const fs::Entry*)item.lParam;
   if (item.mask&LVIF_IMAGE) item.iImage=nodeImage(n);
   if (item.mask&LVIF_TEXT) switch (item.iSubItem) {
    case 0: makeText(n->name,item.pszText,item.cchTextMax); break;
    case 1: if (n->size) makeSizeString(n->size,item.pszText,item.cchTextMax); break;
    case 2: makeDateString(n->ftLastMod,item.pszText,item.cchTextMax); break;
   }
  }break;
 }
}

static int movePaneIndex=-1;
static int moveLastX;
static HIMAGELIST imglist;

static LONG_PTR CALLBACK MainWndProc(HWND Wnd,UINT msg,WPARAM wParam,LPARAM lParam) {
 switch (msg) {
  case WM_CREATE: {
   hMainWnd=Wnd;
   hMainMenu=GetMenu(Wnd);
   imglist=ImageList_LoadImage(hInstance,MAKEINTRESOURCE(1),16,0,CLR_DEFAULT,IMAGE_BITMAP,0);
   config.load();
   hStatus=CreateStatusWindow(WS_VISIBLE|WS_CHILD,TEXT("Status"),Wnd,13);
   hTreeView=CreateWindowEx(WS_EX_CLIENTEDGE,WC_TREEVIEW,0,
	WS_CHILD|WS_VISIBLE|WS_BORDER|TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT|TVS_EDITLABELS|TVS_SHOWSELALWAYS,
	0,0,0,0,Wnd,(HMENU)12,0,0);
   TreeView_SetImageList(hTreeView,imglist,TVSIL_NORMAL);
   hListView=CreateWindowEx(WS_EX_CLIENTEDGE,WC_LISTVIEW,0,
	WS_CHILD|WS_VISIBLE|WS_BORDER|LVS_REPORT|LVS_SINGLESEL|LVS_SHOWSELALWAYS,
	0,0,0,0,Wnd,(HMENU)22,0,0);
   ListView_SetImageList(hListView,imglist,LVSIL_SMALL);
   ListView_SetExtendedListViewStyle(hListView,LVS_EX_GRIDLINES);
   LVCOLUMN c;
   c.mask=LVCF_FMT|LVCF_SUBITEM|LVCF_TEXT|LVCF_WIDTH;
   c.fmt=LVCFMT_CENTER;
   TCHAR s[256];
   LoadString(hInstance,98,s,elemof(s));
   c.pszText=s;
   for (c.iSubItem=0; c.iSubItem<3; c.iSubItem++) {
    if (!(c.cx=config.listDiv[c.iSubItem])) c.cx=LVSCW_AUTOSIZE;
    ListView_InsertColumn(hListView,c.iSubItem,&c);
    c.pszText+=lstrlen(c.pszText)+1;
   }
//   DefListViewProc=SubclassWindow(hListView,RouteKeydownProc);

   hComment =CreateWindowEx(WS_EX_CLIENTEDGE,WC_EDIT,0,
	WS_CHILD|WS_VISIBLE|WS_BORDER,
	0,0,0,0,Wnd,(HMENU)32,0,0);
   msgFind=RegisterWindowMessage(FINDMSGSTRING);
   findreplace.lStructSize=sizeof findreplace;
   findreplace.hwndOwner=Wnd;
   findreplace.Flags=FR_SHOWHELP|FR_DOWN;
   findreplace.lpstrFindWhat=findstr;
   findreplace.wFindWhatLen=elemof(findstr);
   findreplace.lpstrReplaceWith=replacestr;
   findreplace.wReplaceWithLen=elemof(replacestr);
   if (config.flags&1) currentFile.open();
   SetFocus(hTreeView);
  }break;
  case WM_SIZE: {
   if (wParam!=42) SendMessage(hStatus,msg,wParam,lParam);
   RECT rc;
   static const int info[]={1,1,1,13,0};
   GetEffectiveClientRect(Wnd,&rc,const_cast<int*>(info));
   rc.right-=rc.left;
   rc.bottom-=rc.top;
   config.ensurePanes(rc.right);
   HDWP wp=BeginDeferWindowPos(elemof(hWndX));
   for (int i=0; i<elemof(hWndX); i++) {
    int r=i<elemof(config.paneX)?config.paneX[i]:rc.right;
    wp=DeferWindowPos(wp,hWndX[i],0,rc.left,rc.top,r-rc.left,rc.bottom,SWP_NOZORDER);
    rc.left=r+GAPX;
   }
   EndDeferWindowPos(wp);
  }break;
  case WM_INITMENU: {
//      EnableMenuItem((HMENU)wParam,65,SendMessage(hTreeView,EM_CANUNDO,0,0)?MF_ENABLED:MF_GRAYED);
//      EnableMenuItem((HMENU)wParam,66,SendMessage(hTreeView,EM_CANREDO,0,0)?MF_ENABLED:MF_GRAYED);
  }break;
  case WM_LBUTTONDOWN: if (unsigned(movePaneIndex=config.findDivider(moveLastX=GET_X_LPARAM(lParam)))<elemof(config.paneX)) SetCapture(Wnd); break;
  case WM_LBUTTONUP: movePaneIndex=-1; ReleaseCapture(); break;
  case WM_MOUSEMOVE: if ((unsigned)movePaneIndex<elemof(config.paneX)) {
   int dx=GET_X_LPARAM(lParam)-moveLastX;
   moveLastX+=dx;
   dx=(config.paneX[movePaneIndex]+=dx);
//   dx-=config.paneX[movePaneIndex];
//   moveLastX+=dx;
   SendMessage(Wnd,WM_SIZE,42,0);
  }break;
  case WM_COMMAND: switch (LOWORD(wParam)) {
   case 81: if (hFind) SetActiveWindow(hFind);
   else hFind=FindText(&findreplace);
   break;
   case 84: if (hFind) SetActiveWindow(hFind);
   else hFind=ReplaceText(&findreplace);
   break;
   case 101: openfile(Wnd); break;
   case 102: currentFile.save(); break;
   case 104: currentFile.close(); EnableMenuItem(hMainMenu,104,MF_DISABLED); break;
   case 2: SendMessage(Wnd,WM_CLOSE,0,0); break;
   case MAKELONG(12,EN_CHANGE):
   case MAKELONG(12,EN_UPDATE): {	// Nur EN_UPDATE kommt
     EnableMenuItem(hMainMenu,102,Edit_GetModify((HWND)lParam)?MF_ENABLED:MF_GRAYED);
   }break;
  }break;
  case WM_NOTIFY: switch (wParam) {
   case 12: handleTreeNotify(lParam); break;
   case 22: handleListNotify(lParam); break;
  }break;
  case WM_SETFOCUS: SetFocus(hTreeView); break;
  case WM_CLOSE:
  case WM_QUERYENDSESSION: {
      if (!(GetMenuState(hMainMenu,102,0)&MF_GRAYED)) {
        switch (MBox(Wnd,9,MB_YESNOCANCEL|MB_ICONQUESTION|MB_SOUND,currentFile.name)) {
	  case IDNO: goto def;		// don't save, Windows can terminate
	  case IDCANCEL: return FALSE;	// don't save, don't let Windows terminate
	}
	currentFile.save();			// save, then let Windows terminate
      }
   for (int i=0; i<elemof(config.listDiv); i++) {
    config.listDiv[i]=ListView_GetColumnWidth(hListView,i);
   }
   config.save();
  }break;
//    case WM_CLOSE: DestroyWindow(Wnd); break;
  case WM_DESTROY: {
   ImageList_Destroy(imglist);
   wantStop=true;	// Worker-Thread (falls vorhanden) beenden lassen, aber nicht ums Ende kmmern
   stopWorker();
   PostQuitMessage(0); 
  }break;
  case WM_USER: {
   EnableMenuItem(hMainMenu,104,MF_ENABLED);	// Entladen zulassen
   status(21);	// "fertig"
  }break;
  case WM_USER+1: {
   CloseHandle(hWorkerThread);
   hWorkerThread=0;
  }break;
  case WM_TIMER: switch (wParam) {
   case 22:{
    KillTimer(Wnd,wParam);
    LVITEM item;
    item.mask=LVIF_PARAM;
    item.iItem=ListView_GetSelectionMark(hListView);
    item.iSubItem=0;
    ListView_GetItem(hListView,&item);
    pathToStatus((const fs::Entry*)item.lParam);
   }break;
  }break;
  default: if (msg==msgFind) {
   FINDREPLACE&fr=*(FINDREPLACE*)lParam;
   if (fr.Flags&FR_DIALOGTERM) hFind=0;
   if (fr.Flags&FR_FINDNEXT) {
    UINT options=fr.Flags&(FR_DOWN|FR_MATCHCASE|FR_WHOLEWORD);
    char s[256];
    WideCharToMultiByte(CP_UTF8,0,fr.lpstrFindWhat,-1,s,sizeof s,0,0);
    suche(currentFile.xml.root.sub,s);
//	FINDTEXTEX ft={{0,-1},fr.lpstrFindWhat};
//        if (SendMessage(hTreeView,EM_FINDTEXTEX,options,(LPARAM)&ft)>=0) {
//	  Edit_SetSel(hTreeView,ft.chrgText.cpMin,ft.chrgText.cpMax);
//	}else MessageBeep(MB_ICONEXCLAMATION);
   }
  }
 }
def:
 return DefWindowProc(Wnd,msg,wParam,lParam);
}

void WinMainCRTStartup() {
 hInstance=GetModuleHandle(0);
 InitCommonControls();
 WNDCLASS wc={
  CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS,
  MainWndProc,
  0,0,0,
  LoadIcon(hInstance,MAKEINTRESOURCE(1)),
  LoadCursor(0,IDC_SIZEWE),
  (HBRUSH)(COLOR_BTNFACE+1),
  MAKEINTRESOURCE(100),
  MAKEINTATOM(100)
 };
 RegisterClass(&wc);
 LoadString(hInstance,1,MBoxTitle,elemof(MBoxTitle));
 HACCEL hAccel=LoadAccelerators(hInstance,MAKEINTRESOURCE(100));

 hMainWnd=CreateWindowEx(WS_EX_WINDOWEDGE,MAKEINTATOM(100),MBoxTitle,
    WS_OVERLAPPEDWINDOW|WS_CLIPCHILDREN,
    CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
    0,0,0,0);
 ShowWindow(hMainWnd,SW_SHOWDEFAULT);

 MSG msg;
 while (GetMessage(&msg,0,0,0)) {
  if (hAccel && TranslateAccelerator(hMainWnd,hAccel,&msg)) continue;
  if (hDialog && IsDialogMessage(hDialog,&msg)) continue;
  if (hFind && IsDialogMessage(hFind,&msg)) continue;
  if (msg.message==WM_KEYDOWN && msg.wParam==VK_TAB) {
   int iFocus;
   for (iFocus=0; iFocus<elemof(hWndX); iFocus++) {
    if (msg.hwnd==hWndX[iFocus]) break;
   }
   if (iFocus<elemof(hWndX)) {
    if (GetKeyState(VK_SHIFT)<0) --iFocus; else ++iFocus;
    while (iFocus<0) iFocus+=elemof(hWndX);
    while (iFocus>=elemof(hWndX)) iFocus-=elemof(hWndX);
    SetFocus(hWndX[iFocus]);
    continue;	// kein DispatchMessage
   }
  }
  TranslateMessage(&msg);
  DispatchMessage(&msg);
 }
 ExitProcess((UINT)msg.wParam);
}
